;; 
;; %%HEADER%%
;; 

(use srfi-13 miscmacros srfi-1)

(define *current-secret* #f)

(define (start-game io)
  (display "Welcome to Codebreaker!" io)
  (newline io)
  (display "Enter guess: " io))


(define (guess secret what)
  (let ((exact_matches (exact-match-count secret what))
        (number_matches (number-match-count secret what)))
    (call-with-output-string
     (lambda (out)
       (repeat exact_matches
               (display "+" out))
       (repeat number_matches
               (display "-" out))))))

(define (exact-match-count secret guess)
  (count-matches-for secret guess exact-match?))

(define (number-match-count secret guess)
  (count-matches-for secret guess number-match?))


(define (count-matches-for secret guess pred?)
  (fold (lambda (idx count)
          (+ count (if (pred? secret guess idx) 1 0)))
        0
        (iota 4 0)))

(define (exact-match? guess secret index)
  (and
   (< index (string-length secret))
   (< index (string-length guess))
   (char=? (string-ref guess index) (string-ref secret index))))

(define (number-match? guess secret index)
  (and
   (< index (string-length secret))
   (< index (string-length guess))
   (string-contains secret (->string (string-ref guess index)))
   (not (exact-match? guess secret index))))
